
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class RewardsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const rewards = await db.rewards.create(
            {
                id: data.id || undefined,
        
        reward_type: data.reward_type
        ||
        null
            ,
            
        points_amount: data.points_amount
        ||
        null
            ,
            
        cash_value_amount: data.cash_value_amount
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        awarded_at: data.awarded_at
        ||
        null
            ,
            
        expires_at: data.expires_at
        ||
        null
            ,
            
        reason_note: data.reason_note
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await rewards.setUser( data.user || null, {
            transaction,
        });
        
        await rewards.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return rewards;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const rewardsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                reward_type: item.reward_type
            ||
            null
            ,
            
                points_amount: item.points_amount
            ||
            null
            ,
            
                cash_value_amount: item.cash_value_amount
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                awarded_at: item.awarded_at
            ||
            null
            ,
            
                expires_at: item.expires_at
            ||
            null
            ,
            
                reason_note: item.reason_note
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const rewards = await db.rewards.bulkCreate(rewardsData, { transaction });

        // For each item created, replace relation files
        

        return rewards;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const rewards = await db.rewards.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.reward_type !== undefined) updatePayload.reward_type = data.reward_type;
        
        
        if (data.points_amount !== undefined) updatePayload.points_amount = data.points_amount;
        
        
        if (data.cash_value_amount !== undefined) updatePayload.cash_value_amount = data.cash_value_amount;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.awarded_at !== undefined) updatePayload.awarded_at = data.awarded_at;
        
        
        if (data.expires_at !== undefined) updatePayload.expires_at = data.expires_at;
        
        
        if (data.reason_note !== undefined) updatePayload.reason_note = data.reason_note;
        
        
        updatePayload.updatedById = currentUser.id;

        await rewards.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await rewards.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await rewards.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return rewards;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const rewards = await db.rewards.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of rewards) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of rewards) {
                await record.destroy({transaction});
            }
        });


        return rewards;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const rewards = await db.rewards.findByPk(id, options);

        await rewards.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await rewards.destroy({
            transaction
        });

        return rewards;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const rewards = await db.rewards.findOne(
            { where },
            { transaction },
        );

        if (!rewards) {
            return rewards;
        }

        const output = rewards.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await rewards.getUser({
            transaction
        });
        
        
        output.organizations = await rewards.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.reason_note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'rewards',
                        'reason_note',
                        filter.reason_note,
                    ),
                };
            }
            

            
            

            
            if (filter.points_amountRange) {
                const [start, end] = filter.points_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    points_amount: {
                    ...where.points_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    points_amount: {
                    ...where.points_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.cash_value_amountRange) {
                const [start, end] = filter.cash_value_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cash_value_amount: {
                    ...where.cash_value_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cash_value_amount: {
                    ...where.cash_value_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.awarded_atRange) {
                const [start, end] = filter.awarded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    awarded_at: {
                    ...where.awarded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    awarded_at: {
                    ...where.awarded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expires_atRange) {
                const [start, end] = filter.expires_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.reward_type) {
                where = {
                    ...where,
                reward_type: filter.reward_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.rewards.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'rewards',
                        'reason_note',
                        query,
                    ),
                ],
            };
        }

        const records = await db.rewards.findAll({
            attributes: [ 'id', 'reason_note' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reason_note', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reason_note,
        }));
    }

    
};

